/* adc_scan

   Pásztázó mérés az ADC-vel: több csatornát pásztázunk
    - az A0 bemeneten egy potméterrel leosztott feszültséget mérjük
    - az A1 bemeneten egy MCP9700 analóg hőmérő jelét mérjük
    - az A2 bemeneten egy LDR segítségével a fényt mérjük
    - az A3 bemeneten pedig egy referencia feszültséget mérünk

   Az eredményeket feszültségre átszámítva a soros porton kiíratjuk.
*/
#define VDD   4.97                 // Vdd feszültség [V]
int data[4] = {0, 0, 0, 0};

void setup() {
  Serial.begin(115200);            // Adatsebesség = 115 200 baud
  analogReference(DEFAULT);        // Vref = kb. 5V (a tápfeszültség)
  Serial.println("  adc_scan: Pásztázó mérés ADC-vel");
  Serial.println("  - az A0 bemeneten egy potméterrel leosztott feszültségét mérjük");
  Serial.println("  - az A1 bemeneten egy MCP9700 analóg hőmérő jelét mérjük");
  Serial.println("  - az A2 bemeneten egy LDR segítségével a fényt mérjük");
  Serial.println("  - az A3 bemeneten pedig egy referencia feszültséget mérünk");
}

void loop() {
  for (int i = 0; i < 4; i++) {
    data[i] = analogRead (i);
  }
  for (int i = 0; i < 4; i++) {
    float voltage = (data[i] * VDD) / 1024.0;
    Serial.print("  A");
    Serial.print(i);
    Serial.print(" = ");
    Serial.print(voltage, 2);
    Serial.print(" V ");
    switch (i) {
      case 1:  { float tempC = (voltage - 0.5) / 0.01;
        Serial.print(tempC, 1);
        Serial.println(" °C");
        break; }
      case 2:  { float ldr = 10 * VDD / voltage - 10;
        Serial.print(ldr, 3);
        Serial.println(" k");
        break;}
      default: Serial.println(" ");
    }
  }
  Serial.println("  ----------");
  delay(2000);
}
